###############################################################################
#
#   MarathUp - Map Properties Dialog
#
###############################################################################

require "Marathon/PropertyUtils.rb"

module Marathon

	#----------------------------------------------------------------------------------

	EnvironmentTypes = [ # TODO: Load from file
		"Water",
		"Lava",
		"Sewage",
		"Jjaro",
		"Pfhor",
	]
	
	LandscapeTypes = [ # TODO: Load from file
		"Daytime Lh'owon",
		"Nighttime Lh'owon",
		"Moon",
		"Space",
	]
	
	MissionFlags = [
		[0x0001, "Extermination"],
		[0x0002, "Exploration"],
		[0x0004, "Retrieval"],
		[0x0008, "Repair"],
		[0x0010, "Rescue"],
	]
	
	EnvironmentFlags = [
		[0x0001, "Vacuum"],
		[0x0002, "Magnetic"],
		[0x0004, "Rebellion"],
		[0x0008, "Low gravity"],
	]
	
	EntryPointFlags = [
		[0x01, "Single player"],
		[0x02, "Cooperative"],
		[0x04, "Carnage"],
		[0x08, "Capture the flag"],
		[0x10, "King of the hill"],
	]
	
	MapInfoDialog = DialogDefinition.new("Level Properties", 500, 420, [
		StrAttr.new("level_name", "Level Name", 50),
		EnumAttr.new("environment_code", "Environment", EnvironmentTypes),
		FlagsAttr.new("environment_flags", 2, EnvironmentFlags),
		DialogLabel.new("Level Type"),
		FlagsAttr.new("entry_point_flags", 2, EntryPointFlags),
		DialogLabel.new("Mission Type"),
		FlagsAttr.new("mission_flags", 2, MissionFlags),
		EnumAttr.new("physics_model", "Physics model", LandscapeTypes),
		IntAttr.new("song_index", "Music index"), # TODO: Accept file name?
	])

	def Marathon.edit_map_info()
		catch :Abort do
			attrs = get_level_attributes(true)
			MapInfoDialog.edit(attrs)
		end
	end

	#----------------------------------------------------------------------------------

end # module Marathon
		
if not $marathon_edit_map_info
	menu = marathon_submenu()
	menu.add_separator()
	menu.add_item("Level Properties") {Marathon.edit_map_info()}
	$marathon_edit_map_info = true
end

