###############################################################################
#
#   MarathUp - Parameter editing
#
###############################################################################

module Marathon

	#----------------------------------------------------------------------------------

	class ParameterDialog
	
		HTML = <<-END
			<html>
				<head>
					<style type="text/css">
						* {	font-size: small; font-family: Arial, sans-serif; }
					</style>
					<script language="javascript">
						function on_ok() {
							window.close();
						}
					</script>
				</head>
				<body>
					<textarea id=text cols=50 rows=20>%s</textarea> <br>
					<input type=button value="Accept" onclick="on_ok()">
				</body>
			</html>
		END
		
		def initialize()
		end
	
		def edit(attrs)
			#printf("Editing %s\n", attrs) ###
			dlog = UI::WebDialog.new("Parameters", true)
			dlog.set_size(400, 400)
			@dlog = dlog
			html = format(HTML, self.attr_html(attrs))
			#printf("HTML = %s\n", html.inspect) ###
			dlog.set_html(html)
			dlog.set_on_close {
				self.get_values(attrs)
			}
			dlog.show_modal()
		end
		
		def attr_html(attrs)
			lines = []
			for name, value in attrs
				lines.push(format("%s = %s", name, value))
			end
			return lines.join("\n")
		end
		
		def get_values(attrs)
			text = @dlog.get_element_value("text")
			#printf("text = %s\n", text.inspect) ###
			lines = text.split("\n")
			#printf("lines = %s\n", lines.inspect) ###
			new_attrs = {}
			for line in lines
				name, value = line.split(/\s*=\s*/)
				#printf("name = %s, value = %s\n", name.inspect, value.inspect) ###
				if name
					new_attrs[name.strip()] = (value or "").strip()
				end
			end
			for name in attrs.keys()
				if not new_attrs[name]
					#printf("deleting %s\n", name.inspect) ###
					attrs.delete_key(name)
				end
			end
			for name, value in new_attrs
				#printf("setting %s = %s\n", name.inspect, value.inspect) ###
				attrs[name] = value
			end
		end
	
	end # class ParameterDialog

	#----------------------------------------------------------------------------------

#	def Marathon.edit_parameters()
#		catch :Abort do
#			obj = get_selected_group_or_instance()
#			attrs = get_parameters(obj, true)
#			dlog = ParameterDialog.new()
#			dlog.edit(attrs)
#		end
#	end

	def Marathon.edit_parameters(obj)
		attrs = get_parameters(obj, true)
		dlog = ParameterDialog.new()
		dlog.edit(attrs)
	end

	#----------------------------------------------------------------------------------
	
end # module Marathon

#if not $marathon_edit_parameters
#	menu = marathon_submenu()
#	menu.add_item("Group/Instance Parameters") {Marathon.edit_parameters()}
#	$marathon_edit_parameters = true
#end
