###############################################################################
#
#   MarathUp - Platform Properties Dialog
#
###############################################################################

require "Marathon/PropertyUtils.rb"

module Marathon

	#----------------------------------------------------------------------------------
	
	PlatformTypes = [
		"S'pht door",
		"S'pht split door",
		"Locked S'pht door",
		"S'pht platform",
		"Noisy S'pht platform",
		"Heavy S'pht door",
		"Pfhor door",
		"Heavy S'pht platform",
		"Pfhor platform",
	]

	PlatformFlags = [
		[0x00000001, "Initially active"],
		[0x00000002, "Initially extended"],
		[0x00000004, "Deactivate at top and bottom"],
		[0x00000008, "Deactivate at initial level"],
		[0x00000010, "Activate adjacent on deactivate"],
		[0x00000020, "Extends floor to ceiling"],
		[0x00000040, "Comes from floor"],
		[0x00000080, "Comes from ceiling"],
		[0x00000100, "Causes damage"],
		[0x00000200, "Does not activate parent"],
		[0x00000400, "Once only"],
		[0x00000800, "Activates light"],
		[0x00001000, "Deactivates light"],
		[0x00002000, "Player controllable"],
		[0x00004000, "Monster controllable"],
		[0x00008000, "Reverses when obstructed"],
		[0x00010000, "Cannot be externally deactivated"],
		[0x00020000, "Uses native polygon heights"],
		[0x00040000, "Delay before activation"],
		[0x00080000, "Activate adjacent on activate"],
		[0x00100000, "Deactivate adjacent on activate"],
		[0x00200000, "Deactivate adjacent on deactivate"],
		[0x00400000, "Retracts slower"],
		[0x00800000, "Activate adjacent at each level"],
		[0x01000000, "Locked"],
		[0x02000000, "Secret"],
		[0x04000000, "Door"],
	]
	
	PlatformDialog = DialogDefinition.new("Platform Properties", 520, 480, [
		StrAttr.new("tag", "Tag"),
		EnumAttr.new("type", "Type", PlatformTypes),
		FloatAttr.new("speed", "Speed (WU/sec)"),
		IntAttr.new("delay", "Delay"),
		FlagsAttr.new("static_flags", 2, PlatformFlags),
	])

#	def Marathon.edit_platform()
#		catch :Abort do
#			face = get_selected_floor_face()
#			attrs = get_platform_attributes(face, true)
#			PlatformDialog.edit(attrs)
#		end
#	end

	def Marathon.edit_platform()
		catch :Abort do
			faces = get_selected_floor_faces()
			PlatformDialog.edit_entities(faces, PlatformAttrs)
		end
	end

end # module Marathon
		
if not $marathon_edit_platform
	menu = marathon_submenu()
	menu.add_item("Platform Properties") {Marathon.edit_platform()}
	$marathon_edit_platform = true
end
