###############################################################################
#
#   MarathUp - Polygon Properties Dialog
#
###############################################################################

require "Marathon/PropertyUtils.rb"

module Marathon

	#----------------------------------------------------------------------------------
	
	PolygonTypes = [
			"Normal",
			"Item impassable",
			"Monster impassable",
			"Hill",
			"Base",
			"Platform",
			"Light on trigger",
			"Platform on trigger",
			"Light off trigger",
			"Platform off trigger",
			"Teleporter",
			"Zone border",
			"Goal",
			"Visible monster trigger",
			"Invisible monster trigger",
			"Dual monster trigger",
			"Item trigger",
			"Must be explored",
			"Automatic exit"
		]

	PolygonDialog = DialogDefinition.new("Polygon Properties", 350, 300, [
		StrAttr.new("name", "Name"),
		EnumAttr.new("type", "Type", PolygonTypes),
		StrAttr.new("permutation", "Permutation"),
		StrAttr.new("media_index", "Liquid"),
		StrAttr.new("media_lightsource_index", "Liquid light"),
		StrAttr.new("ambient_sound_image_index", "Ambient sound"),
		StrAttr.new("random_sound_image_index", "Random sound"),
	])
	
	#----------------------------------------------------------------------------------
	
	def Marathon.edit_polygon()
		catch :Abort do
			faces = get_selected_floor_faces()
			PolygonDialog.edit_entities(faces, PolygonAttrs)
		end
	end

	#----------------------------------------------------------------------------------
	
end # module Marathon
		
if not $marathon_edit_polygon
	menu = marathon_submenu()
	menu.add_item("Polygon Properties") {Marathon.edit_polygon()}
	$marathon_edit_polygon = true
end
